package betterwithmods.common.world.gen.feature;

import betterwithmods.common.blocks.BlockStump;
import net.minecraft.block.BlockOldLog;
import net.minecraft.block.BlockPlanks;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenBirchTree;

import java.util.Random;

/**
 * Hardcore Stumping tree.
 *
 * @author Koward
 */
public class WorldGenBirchTreeWithStump extends WorldGenBirchTree {
    private static final IBlockState LOG = Blocks.field_150364_r.func_176223_P().func_177226_a(BlockOldLog.field_176301_b, BlockPlanks.EnumType.BIRCH);

    public WorldGenBirchTreeWithStump(boolean notify, boolean useExtraRandomHeightIn) {
        super(notify, useExtraRandomHeightIn);
    }

    @Override
    public boolean func_180709_b(World worldIn, Random rand, BlockPos position) {
        boolean vanillaResult = super.func_180709_b(worldIn, rand, position);
        if (vanillaResult && BlockStump.canPlaceStump(worldIn, position)) {
            IBlockState stump = BlockStump.getStump(LOG);
            if (stump == null) return vanillaResult;
            this.func_175903_a(worldIn, position, stump);
        }
        return vanillaResult;
    }
}
