package betterwithmods.module.hardcore;

import betterwithmods.common.BWSounds;
import betterwithmods.module.Feature;
import betterwithmods.module.ModuleLoader;
import betterwithmods.module.hardcore.hchunger.HCHunger;
import betterwithmods.util.player.HealthPenalty;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.MobEffects;
import net.minecraft.potion.PotionEffect;
import net.minecraftforge.event.entity.living.LivingAttackEvent;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.fml.common.eventhandler.Event;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

/**
 * Created by tyler on 5/24/17.
 */
public class HCInjury extends Feature {


    @SubscribeEvent
    public void attack(LivingAttackEvent event) {
        if (event.getSource().func_76346_g() instanceof EntityPlayer) {
            EntityPlayer player = (EntityPlayer) event.getSource().func_76346_g();
            if (PlayerHelper.isSurvival(player)) {
                HealthPenalty healthPenalty = PlayerHelper.getHealthPenalty(player);
                double mod = healthPenalty.getModifier();
                if (mod <= 0.75) {
                    player.func_184185_a(BWSounds.OOF, 0.75f, 1f);
                    event.setCanceled(true);
                    event.setResult(Event.Result.DENY);
                }
            }
        }
    }

    @SubscribeEvent
    public void penalty(LivingEvent.LivingUpdateEvent event) {
        if (!event.getEntity().func_130014_f_().field_72995_K)
            return;
        if (event.getEntityLiving() instanceof EntityPlayer) {
            EntityPlayer player = (EntityPlayer) event.getEntityLiving();
            if (!PlayerHelper.isSurvival(player))
                return;
            if (player != null) {
                if (!ModuleLoader.isFeatureEnabled(HCHunger.class)) {
                    PlayerHelper.changeSpeed(player, "Health speed penalty", PlayerHelper.getSpeedModifier(player));
                }
                HealthPenalty healthPenalty = PlayerHelper.getHealthPenalty(player);
                double mod = healthPenalty.getModifier();
                if (mod <= 0.25) {
                    if (player.field_70170_p.func_72820_D() % 60 == 0) {
                        player.func_184185_a(BWSounds.OOF, 0.75f, 1f);
                        if (mod <= 0.20)
                            player.func_70690_d(new PotionEffect(MobEffects.field_76440_q, 80, 0, false, false));
                    }
                }
            }
        }
    }

    @Override
    public String getFeatureDescription() {
        return "Add Penalties to lower health levels.";
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }
}
