package betterwithmods.module.tweaks;

import betterwithmods.common.items.ItemMaterial;
import betterwithmods.module.Feature;
import net.minecraft.entity.passive.EntityAnimal;
import net.minecraft.entity.passive.EntityWolf;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

/**
 * Created by tyler on 4/20/17.
 */
public class Dung extends Feature {
    private static final int[] fearLevel = {1600, 1500, 1400, 1300, 1200, 1100, 1000, 900, 800, 700, 600, 500, 400, 300, 200, 100};
    private boolean wolvesOnly;

    @Override
    public String getFeatureDescription() {
        return "Animals will launch dung depending on their conditions, a useful material";
    }

    @Override
    public void setupConfig() {
        wolvesOnly = loadPropBool("Only Wolves", "Only Wolves will produce dung", true);
    }

    @SubscribeEvent
    public void mobDungProduction(LivingEvent.LivingUpdateEvent evt) {
        if (evt.getEntityLiving().func_130014_f_().field_72995_K)
            return;
        if (evt.getEntityLiving() instanceof EntityAnimal) {
            EntityAnimal animal = (EntityAnimal) evt.getEntityLiving();
            if(wolvesOnly && !(animal instanceof EntityWolf))
                return;
            if (!animal.func_130014_f_().func_175678_i(animal.func_180425_c())) {
                if (animal.func_70874_b() > 99) {
                    int light = animal.func_130014_f_().func_175699_k(animal.func_180425_c());
                    if (animal.func_70874_b() == fearLevel[light]) {
                        evt.getEntityLiving().func_70099_a(ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DUNG), 0.0F);
                        animal.func_70873_a(99);
                    }
                }
            }
        }
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }
}
